<?php

use BlueMedia\OnlinePayments\Model\Gateway;

final class SmartneyPopupPaymentMethod implements PaymentGatewayInterface
{
    public function canProcess($currentCurrency, array $bluemediaSettings)
    {
       return $this->isConfigurationSet($currentCurrency, $bluemediaSettings) &&
           $this->isSmartneyChannelEnabled($currentCurrency, $bluemediaSettings) &&
           $currentCurrency == CurrencyEnum::PLN;
    }

    public function process()
    {
        /** @see WC_Payment_Gateway_BlueMedia_Smartney_Popup */
        return 'WC_Payment_Gateway_BlueMedia_Smartney_Popup';
    }

    private function isConfigurationSet($currentCurrency, array $bluemediaSettings) {
        return !empty($bluemediaSettings['service_id_' . $currentCurrency]) &&
            !empty($bluemediaSettings['hash_key_' . $currentCurrency]);
    }

    private function isSmartneyChannelEnabled($currentCurrency, $bluemediaSettings)
    {
         return !empty($bluemediaSettings['backgorund_channels'][$currentCurrency][Gateway::GATEWAY_ID_SMARTNEY]);
    }
}
